config/urls.py
from django.contrib import admin
from django.urls import path, include
from .views import HomeView

# root url 일때 HomeView 로 처리
urlpatterns = [
    path('admin/', admin.site.urls),
    path('', HomeView.as_view(), name='home'),
    path('todo/', include('todo.urls')),
]

todo/urls.py
from django.urls import path
from . import views

app_name = 'todo'
urlpatterns = [
    path('see/', views.TodoVueSee.as_view(), name='see'),
    path('create/', views.TodoCV.as_view(), name='create'),
    path('list/', views.TodoLV.as_view(), name='list'),
    path('<int:pk>/delete/', views.TodoDelV.as_view(), name='delete'),
    path('<int:pk>/delete2/', views.TodoDelV2.as_view(), name='delete2'),
    path('mixin/', views.TodoMulObMixCV.as_view(), name='mixin'),
]

todo/models.py
from django.db import models


class Todo(models.Model):
    name = models.CharField('NAME', max_length=6, blank=True)
    todo = models.CharField('TODO', max_length=100)

    def __str__(self):
        return self.todo

    # 리스트 생성시 name 을 입력하지 않을때 홍길동을 기본값으로 넣어줌
    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        if not self.name:
            self.name = '홍길동'
        super().save()

config/views.py
from django.views.generic import TemplateView


# home.html 은 특정 앱에 포함된 것이 아니니 config 에서 사용한다.
class HomeView(TemplateView):
    template_name = 'home.html'

todo/views.py
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import TemplateView, CreateView, ListView, DeleteView
from django.views.generic.list import MultipleObjectMixin

from .models import Todo


class TodoVueSee(TemplateView):
    template_name = 'todo/todo_vue_see.html'


# 아래 CreateView 는 form 으로 model 과 연동하여 저장하므로 model를 추가 사용한다.
class TodoCV(CreateView):
    model = Todo
    fields = '__all__'         # model 에 모든 필드 사용
    template_name = 'todo/todo_form.html'
    # success_rul 로 redirect 는 reverse_lazy 사용한다. 모듈이 완성되지 않았기 때문.
    success_url = reverse_lazy('todo:list')
    # 함수로 반전시에는 reverse() 를 사용한다.


class TodoLV(ListView):
    model = Todo        # 리스트를 가져오려면 db table 에서 가져오므로 model 사용.
    template_name = 'todo/todo_list.html'


class TodoDelV(DeleteView):
    model = Todo        # list 삭제도 table 에서 삭제하므로 model 사용.
    template_name = 'todo/todo_confirm_delete.html'
    # 삭제후 리로드 하기 위해서 reverse_lazy 사용.
    success_url = reverse_lazy('todo:list')


# 페이지 이동없이 mixin 을 이용하여 추가하기
# object_list 를 Template 로 보내기 위해서( note.txt 참조)
class TodoMulObMixCV(MultipleObjectMixin, CreateView):
    model = Todo
    fields = '__all__'
    template_name = 'todo/todo_form_list.html'
    success_url = reverse_lazy('todo:mixin')

    # self.object_list 만들기 위해 선언하고 Todo model 에서 가져오도록 만든다.
    # get, post 에서 만들어 사용한다.
    def get(self, request, *args, **kwargs):
        self.object_list = self.get_queryset()
        return super().get(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        self.object_list = self.get_queryset()
        return super().post(request, *args, **kwargs)


# 페이지 이동없이 mixin 을 이용하여 삭제하기
class TodoDelV2(DeleteView):
    model = Todo        # list 삭제도 table 에서 삭제하므로 model 사용.
    template_name = 'todo/todo_confirm_delete.html'
    # 삭제후 리로드 하기 위해서 reverse_lazy 사용.
    success_url = reverse_lazy('todo:mixin')

    def get(self, request, *args, **kwargs):
        return self.delete(request, *args, **kwargs)

templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% block title %}home.html{% endblock %}</title>

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.15.1/css/all.css">
    <link rel="icon" href="{% static 'img/favicon.ico' %}">

    {% block extra-style %}{% endblock %}
</head>
<body style="padding-top: 90px">
<!--Main Menu                    fixed-top 사용하면 body 에 padding-top 을 넣어야 한다.-->
    <nav class="navbar navbar-expand-lg navbar-dark bg-primary fixed-top">
        <span class="navbar-brand mx-5 mb-0 font-weight-bold font-italic">Django & Vue</span>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'home' %}">Home</a>
                </li>
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'todo:see' %}">VueSee</a>
                </li>
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'todo:create' %}">Django</a>
                </li>
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'todo:mixin' %}">DjangoMixin</a>
                </li>
                <li class="nav-item dropdown mx-1 btn btn-primary">
                    <a class="nav-link dropdown-toggle"  text="white" href="#" id="dropdown">
                    Util
                    </a>
                    <div class="dropdown-menu">
                        <a class="dropdown-item" href="{% url 'admin:index' %}">Admin</a>
                        <div class="dropdown-divider"></div>
                    </div>
                </li>
            </ul>
            <form class="form-inline my-2">
                <input class="form-control mr-sm-2" type="search" placeholder="Search">
            </form>
            <ul class="navbar-nav ml-5 mr-5">
                <li class="nav-item dropdown mx-1 btn btn-primary">
                    <a class="nav-link dorpdown-toggle text-white" href="#" data-toggle="dropdown">
                        <i class="fas fa-user"></i>&nbsp; Anonymous &nbsp;</a>
                    <div class="dropdown-menu">
                        <a class="dropdown-item" href="{% url 'home' %}">Login</a>
                        <a class="dropdown-item" href="{% url 'home' %}">Register</a>
                    </div>
                </li>
            </ul>
        </div>
    </nav>

    <div class="container">
        {% block content %}{% endblock %}
    </div>

{% block footer %}{% endblock %}

<!--Bootstrap core JavaScript-->
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

{% block extra-script %}{% endblock %}

</body>
</html>

templates/home.html
{% extends 'base.html' %}

{% load static %}

{% block title %}home.html{% endblock %}

{% block extra-style %}
<style type="text/css">

.home-window {
    background-image: url("{% static 'img/dragon.png' %}");
    background-repeat: no-repeat;
    background-position: center;
    background-size: 50%;
    height: 500px;
    border-top: 10px solid #ccc;
    border-bottom: 10px solid #ccc;
    color: yellow;
    padding: 20px 0 0 20px;
}
.title {
    color: #c80;
    font-weight: bold;
}
.powered {
    position: relative;
    top: 77%;
    color: #cc0;
    font-style: italic;
}

.footer-wrapper {
    background: #456;
    color: #eee;
    line-height: 50px;
}
.footer-wrapper a {
    color: #ff9;    /* footer-right text */
}
.footer-wrapper a:hover {
    color: #0ff;
}
footer ul li {
    text-align: center;
}

</style>
{% endblock extra-style %}

{% block content %}
    <div class="home-window">
        <h2 class="title">Django Web</h2>
        <h4 class="powered"><i class="fas fa-cog"></i> django & bootstrap </h4>
    </div>

    <hr style="margin: 10px 0;">

    <div class="row text-center">
        <div class="col-sm-6">
            <h3>Todo App</h3>
            <p>With Todo app, you can manage, prioritize, and complete the most important things
                you need to do every day. I can focus on the most important things
                and I can do my day more deliberately.
                You can also share lists with colleagues, friends, and family.</p>
        </div>
        <div class="col-sm-6">
            <h3>Blog App</h3>
            <p>This application makes it possible to log daily events or write your own interests
                such as hobbies, techniques, etc.
                A typical blog combines text, digital images, and links to other blogs, web pages,
                and other media related to its topic.</p>
        </div>
    </div>
{% endblock content %}

{% block footer %}
<footer class="fixed-bottom footer-wrapper">
    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <p>Copyright &copy; 2020 DjangoWeb </p>
            </div>
            <div class="col-md-8">
                <ul class="list-inline float-right">
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Introduction</a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Help</a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Policy</a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Something</a>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</footer>
{% endblock footer %}

{% block extra-script %}
<script>
$(function () {
    $('[data-toggle=tooltip]').tooltip();
});
</script>
{% endblock extra-script %}

templates/todo/todo_confirm_delete.html
{% extends 'base.html' %}

{% block title %}todo_confirm_delete.html{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }

    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }

    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 70px;
        padding-left: 20px;
    }

    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
    }

    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }

    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }

    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo Delete</h1>
    <p>{{ object }}를 정말 삭제 하시겠습니까?</p>
    <br>
    <form action="." method="post">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger btn-sm">Confirm</button>
    </form>
</div>
{% endblock %}

templates/todo/todo_form.html
{% extends 'base.html' %}

{% block title %}todo_form.html{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 90px;
        padding-left: 20px;
        line-height: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
        line-height: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <form class="inputBox" action="." method="post">
        {% csrf_token %}
        <!--django model 의 field name 과 태그의 속성 name 은 같아야 한다.-->
        <input class="name" type="text" placeholder="이름" name="name">
        <input class="item" type="text" placeholder="할 일을 입력하세요~" name="todo">
        <button type="submit" class="btn btn-info btn-sm">ADD</button>
    </form>
</div>
{% endblock %}

templates/todo/todo_form_list.html
{% extends 'base.html' %}

{% block title %}todo_form.html{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 90px;
        padding-left: 20px;
        line-height: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
        line-height: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
    .removeBtn:hover {
        color: red;
    }
    .modal-footer {
        color: white;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <!--CreateView 에서 연동되는 Template-->
    <form class="inputBox" action="." method="post">
        {% csrf_token %}
        <!--django model 의 field name 과 태그의 속성 name 은 같아야 한다.-->
        <input class="name" type="text" placeholder="이름" name="name">
        <input class="item" type="text" placeholder="할 일을 입력하세요~" name="todo">
        <button type="submit" class="btn btn-info btn-sm">ADD</button>
    </form>
    <!--ListView 에서 연동되는 Template-->
    <ul class="todoList">
        {% for todo in object_list %}
        <li>
            <span>{{ todo.name }}:: {{ todo.todo }}</span>
            <!--삭제 버튼을 클릭시 삭제하는 페이지로 이동하는 url-->
            <!--<button class="removeBtn"><a href="{% url 'todo:delete2' todo.id %}">&#x00D7</a></button>-->

            <!--삭제 버튼 클릭시 팝업 창 -->
            <button class="removeBtn" data-toggle="modal" data-target="#myModal"
                    data-id="{{todo.id}}" data-name="{{todo.name}}" data-todo="{{todo.todo}}">&#x00D7</button>
        </li>
        {% endfor %}
    </ul>

    <!--Modal-->
    <div class="modal" id="myModal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">정말 삭제 하시겠습니까?</h5>
                </div>
                <div class="modal-body">
                    body-text
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary btn-sm" data-dismiss="modal">취소</button>
                    <button type="button" class="btn btn-danger btn-sm"><a href="">삭제</a></button>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

{% block extra-script %}
<script>
$('#myModal').on('show.bs.modal', function (event) {
    /* relatedTarget 의 변수명은 id, name, todo */
    var button = $(event.relatedTarget)
    var id = button.data('id')
    var name = button.data('name')
    var todo = button.data('todo')

    var modal = $(this)
    /* name 과 todo 는 modal-body 에 사용 */
    modal.find('.modal-body').text(name + '::: ' + todo)
                    /* id 는 a 태그의 href 요소의 url를 만드는데 사용한다. */
    modal.find('.modal-footer a').attr('href', '/todo/' + id + '/delete2/')
})
</script>
{% endblock %}

templates/todo/todo_list.html
{% extends 'base.html' %}

{% block title %}todo_list.html{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 70px;
        padding-left: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <ul class="todoList">
        {% for todo in object_list %}
        <li>
            <span>{{ todo.name }}:: {{ todo.todo }}</span>
            <button class="removeBtn"><a href="{% url 'todo:delete' todo.id %}">&#x00D7</a></button>
        </li>
        {% endfor %}
    </ul>
</div>
{% endblock %}

templates/todo/todo_vue_see.html
{% extends 'base.html' %}

{% block title %}todo_vue_see.html{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 90px;
        padding-left: 20px;
        line-height: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
        line-height: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <div class="inputBox">
        <!-- 아래 vue와 데이터 디렉티브 바인딩을 위해 v-model 를 사용하여 vue data option name을 사용. -->
        <input class="name" type="text" placeholder="이름" v-model="name">
        <!-- enter를 사용하여 입력 -->
        <input class="item" type="text" placeholder="할 일을 입력하세요~" v-model="newTodoItem"
                v-on:keyup.enter="add_todo()">
        <!-- 버튼을 클릭하면 add_todo 메서드를 호출 -->
        <button v-on:click="add_todo()" class="btn btn-primary btn-sm">ADD</button>
    </div>
    <ul class="todoList">
        <!-- todoItems 안의 항목들 todo 에 하나씩 대입하여 순차실행 -->
        <li v-for="(todo, index) in todoItems">
            <span>{ todo.name }:: { todo.item }</span>
            <!-- 삭제 remove_todo() 함수 호출 -->
            <button class="removeBtn" type="button" v-on:click="remove_todo(index)">&#x00D7</button>
        </li>
    </ul>
</div>
{% endblock %}

{% block extra-script %}
<!-- 뷰 CDN 연결 -->
<script src="https://unpkg.com/vue/dist/vue.min.js"></script>
<script>
    var vm = new Vue({
        delimiters: ['{', '}'],
        el: '#app',   // element option에 태그 요소 지정하기
        // vue의 데이터 바인딩은 vue에서 html쪽으로 바인딩 반대는 안된다.
        // 예외로 v-model로 바인딩된 data는 양방향 가능하다.
        // 아래 name, newTodoItem은 v-model로 바인딩
        // todoItems는 v-for로 바인딩되고,
        // todoItems내 todo.name, todo.item은 mustache 기번문법으로 바인딩됨
        // 즉 v-model 외의 data 바이딩은 vue에서 html로 데이터 이동
        data: {
            name: '', // 아래 입력한 내용 넣기위해 input 태그에 v-model 속성사용
            newTodoItem: '',
            todoItems:[],
        },
        methods: {
            add_todo: function() {
                // 콘솔로그 확인 및 디버깅을 위해 로그저장
                console.log("add_todo() : ");
                // 입력된 이름이 없으면 경고창이 뜨고 리턴된다.
                if (this.name == "") {
                    alert("이름을 입력하세요!");
                    return;
                }
                if (this.newTodoItem == "") {
                    alert("내용을 입력하세요~");
                    return;
                }
                // todoItems 에 사용자가 입력한 내용 넣기
                this.todoItems.push({name: this.name, item: this.newTodoItem});
                // add push 후 입력항목 클리어하기
                this.name = "";
                this.newTodoItem = "";
            },
            remove_todo: function(index) {
                console.log("remove_todo() : ");
                this.todoItems.splice(index, 1);
            }
        },
    })
</script>
{% endblock %}